# jlog - Just Barely Logging

jlog is a C++ library for logging to file, console, and event callbacks.

![Static Badge](https://img.shields.io/badge/Lit-Based-%20)

## Features

* Modern (C++20)
* Static Library
* Color Output (Now in RGB!)
* Logs to file AND console!
* Idiomatic Event callback for hooking into your game engine gui!
* GCC and MSVC support
* No more macros for traceback!

## Installation

Include this repository as a CPM dependency, and link against the library.

```cmake
CPMAddPackage(
        NAME jlog
        URL https://git.redacted.cc/josh/jlog/archive/Prerelease-7.zip
)
# ...
include_directories(${jlog_SOURCE_DIR}/include)
# ...
target_link_libraries(YourProgram ... jlog)


```

# Usage 
Using jlog is straightforward:

```cpp

#include <jlog/jlog.hpp>

int main() {
    jlog::info("This is barely useful information.");
    jlog::debug("Debugging Information");
    jlog::verbose("Yadda Yadda Yadda");
    jlog::warning("Slight miscalculation!");
    jlog::error("Oops, something went wrong.");
    jlog::fatal("Unrecoverable Error!!!");

    return 0;
}

```

## Output

![Should be sample output...](img.png)

## TODO

* Documentation
* Thread Safety
* Memory Safety
* Stream Support

## License

This software is written and developed by Josh O'Leary @ Redacted Software 2024. This work is dedicated to the public domain.

## Contributing

Send'em pull requests.