#pragma once

#include <string>
#include <jlog/token.hpp>

namespace jlog
{
    /// Writes a std::vector of tokens directly to standard output
    void LogToConsole(const std::vector<token>& ts);

    /// Writes a std::string directly to standard output
    void LogToConsole(const std::string& s);

    /// Writes a std::vector of tokens to the specified logfile
    void LogToFile(const std::string& filename, const std::vector<token>& ts);

    /// Writes a std::string to the specified logfile
    void LogToFile(const std::string& filename, const std::string& s);

    /*
    /// Writes an input string directly to standard output
    /// @note Does not append a newline to the message.
    void log_to_console(const std::string &message);

    /// Writes an input string directly to the specified destination logfile
    /// @note Does not append a newline to the message.
    void log_to_file(const std::string &filename, const std::string &message);
     */
}