/// Josh's Logger
/// A Redacted Software Product
/// Developed & Maintained by Josh O'Leary
/// This work is dedicated to the public domain.

/// Special thanks: Maxine Hayes, William J Tomasine II

#pragma once

#include <string>
#include <map>
#include <Event.h>
#include <mcolor.h>
#include "token.hpp"
#include "formatter.hpp"
#include "source_location"
#include <jlog/logger.hpp>

namespace jlog {

    using namespace mcolor;

    /// Built-in Global Loggers
    extern Logger info;
    extern Logger warning;
    extern Logger error;
    extern Logger fatal;
    extern Logger verbose;
    extern Logger debug;


    void SetTracebackOnGlobalLoggers(bool enabled);
}

