#pragma once

#include <mcolor.h>
#include "Colors.hpp"
#include <source_location>
#include <map>
#include <jlog/token.hpp>
#include <Event.h>

namespace jlog
{
    using namespace mcolor;

    ///
    class Logger {
    public:
        explicit Logger(const std::string& context, const Color4& color = Colors::LightGray);
    public:
        Event<std::vector<token>> OnLogEvent;
    public:
        void operator () (const std::string& message, const std::source_location& location = std::source_location::current());

        virtual void Log(const std::string &message, const std::source_location& location = std::source_location::current());
        //virtual void LogTrace(const std::vector<token> tokens);
        //virtual void LogTrace(const std::string& context, const std::string &message);
        //virtual void LogTrace(const std::string &message, const std::source_location& location = std::source_location::current());
    public:
        void SetEnabled(bool state);
        void Enable();
        void Disable();
        bool Enabled();
        void LogFile(const std::string& f);
        std::string LogFile();
        // no cc no bullshit
        //void SetColorCode(AnsiColor cc = AnsiColor::FG_DEFAULT);
        //AnsiColor GetColorCode();
        void SetColorCode(Color4 cc = Colors::LightGray);
        Color4 GetColorCode();
    public:
        std::string Context();
        void SetTraceback(bool enabled);
        /**/
    protected:
        bool enabled = true;
        std::string logfile = "latest.log";
        //AnsiColor colorcode = AnsiColor::FG_DEFAULT;
        Color4 colorcode = Colors::LightGray;
        std::string context;
        bool trace = true;
    };
}