#include <mcolor.h>
#include <jlog/token.hpp>
#include <jlog/io.hpp>
#include <fstream>
#include <iostream>
#include <chrono>

namespace jlog
{
    // Is there really a need for this? No, I'm just being consistent.
    void LogToConsole(const std::string& s) {
        std::cout << s;
    }

    void LogToConsole(const std::vector<token>& ts) {
        // Disable color output on Windows for now.
#ifdef WIN32
        //std::cout << TokensToString<WithoutColor>(ts);
        LogToConsole(TokensToString<WithoutColor>(ts));
#else
        //std::cout << TokensToString(ts);//<< std::endl;
        LogToConsole(TokensToString(ts));
#endif
    }

    void LogToFile(const std::string& filename, const std::string& s) {
        std::ofstream logfile(filename, std::ios_base::app);
        logfile << s;// << std::endl;
        logfile.close();
    }

    void LogToFile(const std::string& filename, const std::vector<token>& ts) {
        LogToFile(filename, TokensToString<WithoutColor>(ts));
    }


/*
    void log_to_console(const std::string& message)
    {
#ifdef WIN32
        mcolor::windowsSaneify();
#endif
        std::cout << message;
    }

    void log_to_file(const std::string& filename, const std::string& message)
    {
        std::ofstream latest_log(filename, std::ios_base::app);
        latest_log << message;
        latest_log.close();
    }
*/
}